import java.sql.*;

class TestClassForNameApp {

  public static void main (String args[]) {

    try {
      Class.forName("oracle.jdbc.driver.OracleDriver");
    }
    catch(ClassNotFoundException e) {
      System.out.println(
       "Oops! Can't find class oracle.jdbc.driver.OracleDriver");
      System.exit(1);
    }
  
    Connection conn = null;
    Statement  stmt = null;
    ResultSet  rset = null;
    try {
      conn = DriverManager.getConnection(
       "jdbc:oracle:thin:@dssw2k01:1521:orcl","scott","tiger");     

      stmt = conn.createStatement();
      rset = stmt.executeQuery(
       "select 'Hello '||USER||'!' result from dual");
      while(rset.next()) 
        System.out.println(rset.getString(1));
      rset.close();
      rset = null;
      stmt.close();
      stmt = null;
      conn.close();
      conn = null;
    }
    catch(SQLException e) {
      System.out.println("Darn! A SQL error: " + e.getMessage());
    }
    finally {
      if (rset != null)
        try {rset.close();} catch(SQLException ignore) {}
      if (stmt != null)
        try {stmt.close();} catch(SQLException ignore) {}
      if (conn != null)
        try {conn.close();} catch(SQLException ignore) {}
    }
  }
}
